/******************* Mitsubishi electric corporation ********************
*                                                                       *
*  Program name         FREQUPS-MINI Service                            *
*                                                                       *
*  Developed by         Information systems department                  *
*                       of                                              *
*                       Mitsubishi electric corporation,Tokyo,Japan     *
*                                                                       *
*  Copyright (C) 2005 Mitsubishi electric corporation                   *
*                                                                       *
*************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <signal.h>
#include <termios.h>
#include <unistd.h>
/************************************************<MOD:05-05-17:start>***/
/* #include <varargs.h> */
#include <stdarg.h>
/************************************************<MOD:05-05-17:e n d>***/
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <sys/uio.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/time.h>
#include "../common/freqship.h"

#define ERRMSG01 "fopen: %s: File already exists\n"
#define ERRMSG02 "\nFILE(UPSFILE,PMSGERR,PMSGOK) access error\n"
#define ERRMSG03 "\ncom-port(%s)open error\n"
#define ERRMSG04 "\nchild process make error\n"
#define ERRMSG05 "FREQSHPD-PID file(%d) open error\n"
#define ERRMSG06 "\ncom-port clear error\n"
#define ERRMSG07 "com-port RTS set eror\n"
#define ERRMSG08 "\ncom-port status get error\n"
#define ERRMSG09 "*** UPS cable connect ERROR !!\n"
#define ERRMSG10 "\n*** Input Power FAIL !! ***\n"
#define ERRMSG11 "*** System shutdown start in %d seconds\n"
#define ERRMSG12 "Power failure : System shutdown start in %d sec"
#define ERRMSG13 "\n *** UPS Low battery signal  FAIL !!\n *** UPS turn off in few seconds\n *** Start system shutdown\n"
#define ERRMSG14 "\n*** Starting System Shutdown. !!\n"
#define ERRMSG15 "Power failure : starting System Shutdown."
#define ERRMSG16 "\n\n*** Input Power RESTORED !!\n"
#define ERRMSG17 "*** Input Power RESTORED !!"

char *idf = "/var/run/freqshpd.pid";

char  Mailerr[256];
char  Mailok[256];
char  Mailto[256];
char  msg[256];
char  MstrAdr[256];
char  Portname[256];

long  Delay;

int   batterystatus;
int   Chgfile;
int   linestatus;
int   Mailsend;
int   Refresh;
int   ret;
int   Slave;			/* connect to ups      0 = real  1 = network */
int   Upslow;			/* battery low         1 = plus  0 = minus  */
int   Upspow;			/* input power         1 = plus  0 = minus  */
int   Upsrmt;			/* ups remote shutdown 1 = plus  0 = minus  */

static int   Mode_Port  = 401;
static int   Mode_Delay =  10;

#ifdef FREQ_NET
    int   NetStatus;
    unsigned long inaddr = (unsigned) -1;
    int   nochangecnt = 0;
#endif

unsigned long NET_GetServerAddr (char *Server);
int NET_Check (unsigned long Server, int Port);
int NET_Serve (int Port, int MaxWait);

static void BroadcastMessage(char *dest, char *message);
int  CheckBatteryLow(int pow, int bat, int pd);
int  CheckPowerFail(int pow, long *powerdowntime_p);
int  CheckCable(int);
int  CronProc(int pd, struct termios *termdata);
void GetComStat(int pd);
time_t GetFileMtime(char *filenamme);
long GetShutdownTime(void);
int  GetUpsModel(void);
void HostDown(int);
void InitializeComport(int pd);
static void MailMessage(char *message);
int  OpenComPort(struct termios *termdata);
void ReadFunc();
int  ReadUpsfile();
void SavePID(void);
void SaveUpsStat(int dmn, int pow, int bat, long time_rest);
void SendForkErrorMess(void);
void SendPowerBackMess(void);
void SendPowerFailMess(void);
void SendShutdownMess(void);

#ifdef FREQ_NET
unsigned long NET_GetServerAddr (char *Server);
int NET_Check (unsigned long Server, int Port);
int NET_Serve (int Port, int MaxWait);
#endif


#ifdef FREQ_CGI
int SaveStatus();    /* for the cgi */
#endif

/*********************************************************
*   ᥤؿ                                           *
*********************************************************/
int main()
{
    FILE *fp;
    int  upstype;
    int  pd;
    int status,id, i;
    int firstflg;
    char msg[255];
    struct termios termdata;

    /*  ӣ٣ӣ̣ϣ ץ  */
    openlog("freqshpd",LOG_PID,LOG_DAEMON);

    /* ʥ */
    signal(SIGHUP, SIG_IGN);
    signal(SIGPIPE, SIG_IGN);
    signal(SIGUSR1, ReadFunc);

    /* ˵ưλϽλ */
    if (fp = fopen(idf, "r")) {
        /*    ERRMSG01 "fopen: %s: File already exists\n"	*/
        sprintf(msg, ERRMSG01, idf);
        MailMessage( msg );
        BroadcastMessage("*", msg );
        syslog(LOG_NDELAY | LOG_INFO, "%s", msg);
        SaveUpsStat(1, 0, 0, 0);
        fclose(fp);
        exit(1);
    }
    /* գУӣƣɣ̣ɹ */
    ret = ReadUpsfile();
    if (ret == 1) {
        /*    ERRMSG02 "\nFILE(UPSFILE,PMSGERR,PMSGOK) access error\n"	*/
        sprintf(msg,ERRMSG02);
        MailMessage( msg );
        BroadcastMessage("*", msg );
        syslog(LOG_NDELAY | LOG_INFO, "%s", msg);
        SaveUpsStat(1, 0, 0, 0);
        exit(1);
    }

    /* ҥץκ */
    switch(id = fork()){
        case -1: /* 顼 */
            /* fprintf(stderr,"\nchild process make error\n");	*/
            SendForkErrorMess();
            SaveUpsStat(1, 0, 0, 0);
            unlink(idf);
            exit(1);
        case  0: /* ҥץ  */
            break;
       	default: /* ƥץ */
            exit(0);
    }

    /**  ҥץ **/
#ifdef FREQ_NET
    if (Slave) {
        if ((inaddr = NET_GetServerAddr(MstrAdr)) == (unsigned) -1) {
            SaveUpsStat(1, 0, 0, 0);
            exit(1);
        }
    } else {
#endif
    /* ãϣͥݡȥץ */
         pd = OpenComPort(&termdata);
#ifdef FREQ_NET
    }
#endif
    /* 䡥˥ץɣĤǼ */
    SavePID();
   	if (!Slave) {
        /* ãϣͥݡȤΥ˥饤 */
        InitializeComport(pd);
    }
	/*   Υᥤؿ   */
    CronProc(pd, &termdata);
}
/*********************************************************
*   Υᥤؿ                                     *
*********************************************************/
int CronProc(int pd, struct termios *termdata)
{
    FILE *fp;
    int firstflg;
    char msg[255];
    long time_rest;
    int  dmn = 0, pow = 0, bat = 0;
    int  pol_time;
    struct timeval  tp;
    struct timezone tzp;
    long powerdowntime;
    time_t mtime_start;

    time_rest = Delay;
    
    /*  ӣ٣ӣ̣ϣ ץ  */
    openlog("freqshpd",LOG_PID,LOG_DAEMON);

    /* UPSFILE  ե뽤μ */
    mtime_start = GetFileMtime(UPSFILE);

    firstflg = 1;
    pol_time = Refresh;
#ifdef FREQ_NET
    NetStatus = S_OK;
#endif

   /********************           **********/
    while(1){
        /* եιټ¹Ԥ */
        if (Chgfile == 1) {
#ifdef FREQ_NET
            if (!Slave) {
#endif
                /* ãϣͥݡȤΥ˥饤 */
                InitializeComport(pd);
#ifdef FREQ_NET
            }
#endif
            Chgfile = 0;
        }
#ifdef FREQ_NET
        if (Slave) {
#ifdef FREQ_CGI
            if(firstflg == 1){
                SaveStatus( 0 );
            }
#endif
            if ((ret = NET_Check(inaddr, Mode_Port)) >= 0 ) {
                 linestatus    = 0;
                 batterystatus = 0;
            }
            Upspow = 1;
            Upslow = 1;
            if (ret == S_ONBAT) {
                linestatus  = 1;
            } else if (ret == S_LOBAT) {
                linestatus    = 1;
                batterystatus = 1;
            } else if (ret == S_NOCHANGE) {
                nochangecnt++;
                if (nochangecnt > 40) {
                    LogError("main", "server down");
                    syslog(LOG_NDELAY | LOG_INFO, "%s", 
                           "Cannot connect server. server down?");
#ifdef FREQ_CGI
                    SaveStatus( 2 );
#endif
                    SaveUpsStat(1, 0, 0, 0);
                    unlink(idf);
                    exit(1);
                }
            } else if (ret == S_ERROR) {
                LogError("main", "ups error");
                syslog(LOG_NDELAY | LOG_INFO, "%s", 
                       "Get \"ups error\" from the server.");
                SaveUpsStat(1, 0, 0, 0);
                unlink(idf);
                exit(1);
            }
            if (ret != S_NOCHANGE) {
                nochangecnt   = 0;
            }
        } else {
#endif  /* FREQ_NET */

        	/* ãϣͥݡȤΥơ */
        	GetComStat(pd);

        	/* ȻŤĥХåƥϥ֥̤³Ȥ
                  ưʤ */
            if(firstflg == 1){
                firstflg = CheckCable(pd);
                /* freqshpd start  syslog ˵Ͽ롣 */
                syslog(LOG_INFO,"freqshpd started.");
            }
#ifdef FREQ_NET
        }
#endif
        /* ȯå */
        if (Upspow != -1) {
            if(pow == 0) {
                if((pow = CheckPowerFail(pow, &powerdowntime)) == 1) {
#ifdef FREQ_NET
                    NetStatus = S_ONBAT;
#endif
                    /* ȯå */
                    SendPowerFailMess();
                    pol_time = 1;
                }
            } else {
                if((pow = CheckPowerFail(pow, &powerdowntime)) == 1) {
                    if(CheckOsShutdownTime(powerdowntime, &time_rest) == 0) {
                        /* Ťˤ륷åȥ */
                        SendShutdownMess();
                        SaveUpsStat(1, 1, 0, 0);
                        HostDown(pd);
                    }
                } else {
                    /* ŻΥå */
#ifdef FREQ_NET
                    NetStatus = S_OK;
#endif
                    SendPowerBackMess();
                    pol_time = Refresh;
                    time_rest = Delay;
                }
            }
        }
        /* Хåƥ㲼ȯå */
        if (Upslow != -1) {
            if((bat = CheckBatteryLow(pow, bat, pd)) == 1) {
#ifdef FREQ_NET
                NetStatus = S_LOBAT;
#endif
                strcpy(msg,ERRMSG13);
                MailMessage( msg );
                BroadcastMessage("*", msg );
#ifdef FREQ_NET
                if (Slave)
                    time_rest = 0;
                else {
                    NET_Serve(Mode_Port, Mode_Delay);
#endif
                    time_rest = Mode_Delay;
#ifdef FREQ_NET
                }
#endif
                SaveUpsStat(1, 1, 1, 0);
                sleep(1);
                HostDown(pd);                  /* åȥ */
            }
        }
        SaveUpsStat(dmn, pow, bat, time_rest);

#ifdef FREQ_NET
        if (Slave) {
            sleep(pol_time);
        } else {
            NET_Serve(Mode_Port, pol_time);
        }
#else
        sleep(pol_time);
#endif  /* FREQ_NET */

        /* UPSFILE  åѹξɤ߹ߤ롣 */
        if(GetFileMtime(UPSFILE) > mtime_start)
    		ret = ReadUpsfile();
    } /** end while loop **/
    return 0;
}

/************************************************************************
*   åΥ֥ɥ㥹ȤԤ                                  *
************************************************************************/
static void
BroadcastMessage(char *dest, char *message)
/*
        char    *dest;          * IN:(ڡڤ) *
        char    *message;       * IN:֥ɥ㥹Ȥʸ *
*/
{
        char destlist[260];
        char *token;
        FILE *fp;
        char command[256];

        strcpy(destlist, dest);
        token = strtok(destlist, " ");
        while (token) {
            if (*token == '*') {
                strcpy(command, "wall");
            } else {
                sprintf(command, "write %s", token);
            }
            if (fp = popen(command, "w")) {
                fprintf(fp, "\n");
                fprintf(fp, "%s\n", message);
                pclose(fp);
            }
            if (fp = fopen("/dev/console", "w")) {
                fprintf(fp, "\r\n\n\n");
                fprintf(fp, "%s\n\n\r", message);
                fclose(fp);
            }
            token = strtok(NULL, " ");
        }
}

/*********************************************************
    Хåƥ㲼ȯå                             *
*********************************************************/
int CheckBatteryLow(int pow, int bat, int pd)
{
    char msg[256];
    if( ( (Upslow == 0) && (!batterystatus) )
           || ((Upslow == 1) && (batterystatus)) ) {
        strcpy(msg, "\n*** UPS Low battery signal  FAIL !!");
        strcat(msg, "\n *** UPS turn off in few minute");
        strcat(msg, "\n *** Start system shutdown\n");
        BroadcastMessage("*", msg );
        syslog(LOG_NDELAY | LOG_INFO, "%s",
           "Low Battery : starting Systen Shutdown.");
        bat = 1;
    }
    else
        bat = 0;
    return bat;
}

/*********************************************************
*   ֥åؿ                                 *
*********************************************************/
int CheckCable(int pd)
{
    if( ((Upspow == 0) && (!linestatus)) ||
        ((Upspow == 1) && ( linestatus)) ||
        ((Upslow == 0) && (!batterystatus)) ||
        ((Upslow == 1) && ( batterystatus)) )
    {
		/* ERRMSG09 "*** UPS cable connect ERROR !!\n" */
		sprintf(msg,ERRMSG09);
        BroadcastMessage("*", msg );

        syslog(LOG_INFO, "UPS cable connect Error : Cannot start freqshpd.");
#ifdef FREQ_CGI
        SaveStatus( 2 );
#endif
        SaveUpsStat(1, 0, 0, 0);
        close(pd);
        unlink(idf);
        exit(1);
    }
    return 0;
}

/*********************************************************
*   ϣӥåȥΥå                     *
*********************************************************/
int CheckOsShutdownTime(long powerdowntime, long *time_rest_p)
{
    int os_shutdown;
    struct timeval  tp;
    struct timezone tzp;
    char msg[256];

    gettimeofday(&tp,&tzp);
    *time_rest_p = Delay - (tp.tv_sec - powerdowntime);
    if(*time_rest_p <= 0)
        os_shutdown = 0;
    else
        os_shutdown = 1;
    return os_shutdown;
}

/*********************************************************
    ȯȯå                           *
*********************************************************/
int CheckPowerFail(int pow, long *powerdowntime_p)
{
    char msg[256];
    struct timeval  tp;
    struct timezone tzp;

    if( ((Upspow == 0) && (!linestatus)) ||
             ((Upspow == 1) && (linestatus)) ) {
        if(pow != 1){   /* ȯ */
            gettimeofday(&tp,&tzp);
            *powerdowntime_p = tp.tv_sec;
        }
        pow = 1;
    } else pow = 0;
    return pow;
}

/*********************************************************
*   ãϣͥݡȤΥơ                       *
*********************************************************/
void GetComStat(int pd)
{
    int status;
    char msg[256];

    if(ioctl(pd,TIOCMGET,&status) < 0){
        strcpy(msg, "\ncom-port status get error\n");
        BroadcastMessage("*", msg );
        strcpy(msg, "Com-port status get error");
        syslog(LOG_NDELAY | LOG_INFO, "%s", msg);
        SaveUpsStat(1, 0, 0, 0);
        unlink(idf);
        exit(1);
    }
    /* ơ */
    linestatus = status & TIOCM_CTS;     /* Ÿ */
/************************************************<MOD:05-06-30:start>***/
/*    batterystatus = status & TIOCM_CD;   ** Хåƥ ** */
    batterystatus = status & TIOCM_DSR;   /* Хåƥ */
/************************************************<MOD:05-06-30:e n d>***/
}

/*********************************************************
*   եνμ                             *
*********************************************************/
time_t GetFileMtime(char *filenamme)
{
    struct stat stat_buff;

    stat(UPSFILE, &stat_buff);

    return stat_buff.st_mtime;
}

/*********************************************************
*   åȥ                                   *
*********************************************************/
void HostDown(int pd)
{
    int status;
    char msg[255];

    /* ãϣͥݡȤΥ */
    close(pd);

    sprintf(msg, "\nStarting system shutdown now!!!");
    BroadcastMessage("*", msg );
    syslog(LOG_INFO, msg);

    /* ӣ٣ӣ̣ϣǳǼ(freqshpd end)  */
        syslog(LOG_INFO,"freqshpd end.");

    /* 䡥κ */
    unlink(idf);

    /* åȥ */
    system("/bin/sync");
    system("/bin/sync");
    system("/bin/sync");

    /* åȥ󳫻 */
    system("shutdown -h now");

    exit(0);
}

/*********************************************************
*   ãϣͥݡȤ ˥饤                        *
*********************************************************/
void InitializeComport(int pd)
{
    char msg[256];
    int clr;

    /* ãϣͥݡȤΥꥢ */
    clr = 0;
    if (Upsrmt == 0) {
        /* գУӥ⡼ȥåȥθ */
        clr = TIOCM_DTR;
    }
    if(ioctl(pd, TIOCMSET, &clr) < 0){
        /* ERRMSG06 "\ncom-port clear error\n"	*/
       	strcpy(msg,ERRMSG06);
       	MailMessage( msg );
       	BroadcastMessage("*", msg );
       	syslog(LOG_NDELAY | LOG_INFO, "%s", msg);
       	SaveUpsStat(1, 0, 0, 0);
       	unlink(idf);
       	exit(1);
     }
     /* ңԣӤ򥻥åȡãԣҤȣģãĤȣˤ */
     clr |= TIOCM_RTS;
     if (ioctl(pd, TIOCMSET, &clr) < 0){
         /* ERRMSG07 "com-port RTS set eror\n"	*/
       	 strcpy(msg,ERRMSG07);
         MailMessage( msg );
         BroadcastMessage("*", msg );
         syslog(LOG_NDELAY | LOG_INFO, "%s", msg);
       	 SaveUpsStat(1, 0, 0, 0);
       	 exit(1);
     }
     sleep(1);
}

/*********************************************************
*   ãϣͥݡȤ򥪡ץ                               *
*********************************************************/
int OpenComPort(struct termios *termdata)
{
    FILE *fp;
    char buff[1024];
    char portname[20];
    char msg[256];
    int  pd;

    /* գУӣƣɣ̣ɹ */
    ret = ReadUpsfile();
    if (ret == 1) {
        sprintf(msg,ERRMSG02);
        MailMessage( msg );
        BroadcastMessage("*", msg );
        syslog(LOG_NDELAY | LOG_INFO, "%s", msg);
        SaveUpsStat(1, 0, 0, 0);
        exit(1);
    }

    if((pd = open(Portname, O_RDWR | O_NDELAY)) < 0){
		/*	ERRMSG03 "\ncom-port(%s)open error\n"	*/
        sprintf(msg,ERRMSG03,Portname);
        MailMessage( msg );
        BroadcastMessage("*", msg );
        syslog(LOG_NDELAY | LOG_INFO, "%s", msg);
        SaveUpsStat(1, 0, 0, 0);
        exit(1);
    }
    /* λãϣͥݡȥơ³ */
    ret = tcgetattr(pd, termdata);
    termdata->c_cflag &= ~HUPCL;
    ret = tcsetattr(pd, TCSANOW, termdata);
    return pd;
}

/************************************************************************
*   桼߽Ԥ                                        *
************************************************************************/
void ReadFunc()
{
        int  ret;
        char msg[255];

        /* գУӣƣɣ̣ɹ */
        ret = ReadUpsfile();
        if (ret == 1) {
            strcpy(msg,ERRMSG02);
            MailMessage( msg );
            BroadcastMessage("*", msg );
            syslog(LOG_NDELAY | LOG_INFO, "%s", msg);
            unlink(idf);
            SaveUpsStat(1, 0, 0, 0);
            exit(1);
        }
        Chgfile = 1;

        signal(SIGUSR1, ReadFunc);
}

/************************************************************************
*   ƣɣ̣ŤɹߤԤ                                              *
************************************************************************/
int
ReadUpsfile()
{
    FILE *fp;
    char buff[256];
    int  len;

    /* գУӣƣɣ̣Ťɹ */
    if((fp = fopen(UPSFILE,"r")) == NULL){
        return(1);
    }
    Slave = 0;
    strcpy(MstrAdr,"");
    while(fgets(buff,sizeof(buff),fp)){
        if (buff[strlen(buff)-1] == '\n')
            buff[strlen(buff)-1] = '\0';

        if (strncmp(buff,"Port=",5) == 0){
            strcpy(Portname,&buff[5]);
        }else if (strncmp(buff,"Delay=",6) == 0){
            Delay = atol(&buff[6]);
        }else if (strncmp(buff,"Mailsend=",9) == 0){
            Mailsend = atoi(&buff[9]);
        }else if (strncmp(buff,"Mailto=",7) == 0){
            strcpy(Mailto,&buff[7]);
        }else if (strncmp(buff,"Upsbatt=",8) == 0){
            Upspow = atoi(&buff[8]);
        }else if (strncmp(buff,"Upslow=",7) == 0){
            Upslow = atoi(&buff[7]);
        }else if (strncmp(buff,"Upsrmt=",7) == 0){
            Upsrmt = atoi(&buff[7]);
        }else if (strncmp(buff,"Refresh=",8) == 0){
            Refresh = atoi(&buff[8]);
        }else if (strncmp(buff,"Slave=",6) == 0){
            Slave = atoi(&buff[6]);
        }else if (strncmp(buff,"MstrAdr=",8) == 0){
            strcpy(MstrAdr,&buff[8]);
        }
    }
    fclose(fp);
    if (Slave == 1) {
        Mailsend = 0;
    }

    /* УͣӣǣţңҤɹ */
    if((fp = fopen(PMSGEFILE,"r")) == NULL){
        return(1);
    }
    len = 0;
    Mailerr[0] = '\0';
    while(fgets(buff,sizeof(buff),fp)){
        len += strlen(buff);
        if (len < 256) {
            strcat(Mailerr, buff);
        }
    }
    fclose(fp);

    /* Уͣӣǣϣˤɹ */
    if((fp = fopen(PMSGOFILE,"r")) == NULL){
        return(1);
    }
    len = 0;
    Mailok[0] = '\0';
    while(fgets(buff,sizeof(buff),fp)){
        len += strlen(buff);
        if (len < 256) {
            strcat(Mailok, buff);
        }
    }
    fclose(fp);

    return(0);
}

/*********************************************************
*   ץɣĤǼ                                   *
*********************************************************/
void SavePID(void)
{
    FILE *fp;
    char msg[256];

    /* 䡥˥ץɣĤǼ */
    if(!(fp = fopen(idf, "w"))){
		/*	ERRMSG05 "FREQSHPD-PID file(%d) open error\n"	*/
        sprintf(msg,ERRMSG05,idf);
        MailMessage( msg );
        BroadcastMessage("*", msg );
        syslog(LOG_NDELAY | LOG_INFO, "%s", msg);
        SaveUpsStat(1, 0, 0, 0);
        exit(1);
    }
    fprintf(fp,"%d\n",(int)getpid());
    fclose(fp);
}

/************************************************************************
*   ֤ν񤭹ߤԤ    (cgi)                                 *
************************************************************************/
#ifdef FREQ_CGI
int SaveStatus(int power)
/* int power     IN : Ÿξ   ̤³/۾/:2/1/0 */
{
        FILE *fp;
        char buff[256];

        /* ӣԣԣգӤ򥪡ץ */
        if((fp = fopen(STATFILE,"w")) == NULL){
                return(1);
        }
        fprintf(fp, "%d\n", power);
        fclose(fp);

        return(0);
}
#endif /* FREQ_CGI */

/*********************************************************
*   UPS ƥ򥻥֤ؿ                       *
*********************************************************/
void SaveUpsStat(int dmn, int pow, int bat, long time_rest)
/*  dwn : daemon      1 = stop   0 = run
    pow : input power 1 = fail   0 = normal
    bat : battery low 1 = low    0 = normal
    time_rest : time(sec) to system shutdown
*/
{
    FILE *fp;
    char msg[256];

    /** Save ups-status to the file "UPSSTAT". **/ 
    if((fp = fopen(UPSSTAT, "w")) == NULL){
        fprintf(stderr,"\nUPSSTAT open error for status data\n");
        strcpy(msg, "UPSSTAT open error for status data");
        syslog(LOG_NDELAY | LOG_INFO, "%s", msg);
        SaveUpsStat(1, 0, 0, 0);
        exit(1);
    }
    fprintf(fp, "Daemon=%d\nInputPower=%d\nBatteryStat=%d\nTimeRest=%d\n", 
            dmn, pow, bat, time_rest);
    fclose(fp);
}

/*********************************************************
*   ҥץ顼Υå                 *
*********************************************************/
void SendForkErrorMess(void)
{
    char msg[256];

	/*	ERRMSG04 "\nchild process make error\n"	*/
    strcpy(msg, ERRMSG04);
    MailMessage( msg );
    BroadcastMessage("*", msg );
    syslog(LOG_NDELAY | LOG_INFO, "%s", msg); 
}

/*********************************************************
     ŻΥå                              *
*********************************************************/
void SendPowerBackMess(void)
{
    char msg[256];

    MailMessage( Mailok );
    BroadcastMessage("*", ERRMSG16);
    syslog(LOG_NDELAY | LOG_INFO, "%s", ERRMSG17);
}

/*********************************************************
*   ȯå                               *
*********************************************************/
void SendPowerFailMess(void)
{
    char msg[256];

    /* send a mail */
    MailMessage( Mailerr );
    /***  "\n*** Input Power FAIL !! ***\n"  */
    BroadcastMessage("*", ERRMSG10);
    /***  "*** System shutdown start in %d seconds\n"  */
    sprintf(msg, ERRMSG11, Delay);
    BroadcastMessage("*", msg );
    /***  "Power failure : System shutdown start in %d sec"  */
    syslog(LOG_NDELAY | LOG_INFO, ERRMSG12, Delay);
}

/*********************************************************
*   ȥå                           *
*********************************************************/
void SendShutdownMess(void)
{
    char msg[256];

    /*** "\n*** Starting System Shutdown. !!\n"  */
    BroadcastMessage("*", ERRMSG14);
    /***  "Power failure : starting System Shutdown."  */
    syslog(LOG_NDELAY | LOG_INFO, "%s", ERRMSG15);
}

/************************************************************************
*   åΥ᡼Ԥ                                        *
************************************************************************/
static void
MailMessage(char *message)
/* char *message;        IN:֥ɥ㥹Ȥʸ     */
{
    FILE *fp;
    char command[256];

    if (Mailsend == 0) {
        return;
    }
    sprintf(command, "nkf | mail -s \"message from FREQSHIP\" %s\n", Mailto);
    if (fp = popen(command, "w")) {
        fprintf(fp, "%s\n", message);
        pclose(fp);
    }
}
